package me.km.afk;

import me.km.KajetansMod;
import me.km.api.GlobalText;
import me.km.api.Module;
import me.km.api.ModuleCommand;
import me.km.api.Utils;
import me.km.exception.PlayerNotFoundException;
import me.km.permissions.Permissions;
import net.minecraft.command.ICommandSender;
import net.minecraft.entity.player.EntityPlayer;

public class CommandAFK extends ModuleCommand
{
    public CommandAFK(Module m) 
    {
        super("afk", m);
        super.setDescription("Schaltet den AFK-Zustand ein / aus");
        super.setUsage("/afk [player]");
        super.setPermission(Permissions.AFK);
    }

    @Override
    public boolean execute(ICommandSender cs, String[] arg) 
    {
        EntityPlayer affectedPlayer;
        try
        {
            if(!KajetansMod.perms.has(cs, Permissions.AFK))
            {
                throw new IndexOutOfBoundsException();
            }   
            affectedPlayer = Utils.getPlayerByName(arg[0]); 
        }
        catch(PlayerNotFoundException ex)
        {
            this.getModule().send(cs, GlobalText.cantFindPlayer(arg[0]));
            return true;
        }
        catch(IndexOutOfBoundsException ex)
        {
            if(!(cs instanceof EntityPlayer))
            {
                this.getModule().send(cs, GlobalText.missingParameter());
                return true;
            }
            affectedPlayer = (EntityPlayer) cs;
        }

        AfkListener man = KajetansMod.afkManager.getEvent(AfkListener.class);
        if(man.isAfk(affectedPlayer))
        {
            man.setAfk(affectedPlayer, false);
            this.getModule().send(affectedPlayer, "Du bist nicht mehr AFK.");
            if(!cs.equals(affectedPlayer))
            {
                this.getModule().send(cs, affectedPlayer.getName() + " ist nicht mehr AFK.");
            }
            return true;
        }
        man.setAfk(affectedPlayer, true);
        this.getModule().send(affectedPlayer, "Du bist nun AFK.");
        if(!cs.equals(affectedPlayer))
        {
            this.getModule().send(cs, affectedPlayer.getName() + " ist nun AFK.");
        }
        return true;
    }
}
