package me.km.api;

import java.util.List;
import net.minecraft.command.CommandBase;
import net.minecraft.command.ICommandSender;
import net.minecraft.server.MinecraftServer;
import net.minecraft.util.math.BlockPos;

public abstract class ModuleTabCommand extends ModuleCommand
{
    private final List<String> list;
    private final int argument;
    
    public ModuleTabCommand(String name, Module m, List<String> list, int argument) 
    {
        super(name, m);
        this.list = list;
        this.argument = argument;
    }

    @Override
    public List<String> getTabCompletions(MinecraftServer server, ICommandSender sender, String[] args, BlockPos targetPos) 
    {
        return args.length == argument + 1 ? 
                CommandBase.getListOfStringsMatchingLastWord(args, list) : 
                super.getTabCompletions(server, sender, args, targetPos);
    }
}
