package me.km.chatmanager;

import me.km.KajetansMod;
import me.km.api.GlobalText;
import me.km.api.Module;
import me.km.api.ModuleCommand;
import me.km.api.Utils;
import me.km.exception.PlayerNotFoundException;
import me.km.permissions.Permissions;
import net.minecraft.command.ICommandSender;
import net.minecraft.entity.player.EntityPlayer;

public class CommandFakeRank extends ModuleCommand
{
    public CommandFakeRank(Module m) 
    {
        super("fakerank", m);
        super.setDescription("Gibt einem Spieler einen falschen Rang");
        super.setUsage("/fakerank <rank/clear> [player]");
        super.setPermission(Permissions.FAKERANK);
    }

    @Override
    public boolean execute(ICommandSender cs, String[] arg) 
    {
        if(arg.length < 1)
        {
            return false;
        }
        EntityPlayer affectedPlayer;
        try
        {
            affectedPlayer = Utils.getPlayerByName(arg[1]);                   
        }
        catch(PlayerNotFoundException ex)
        {
            this.getModule().send(cs, GlobalText.cantFindPlayer(arg[1]));
            return true;
        }
        catch(IndexOutOfBoundsException ex)
        {
            if(!(cs instanceof EntityPlayer))
            {
                this.getModule().send(cs, GlobalText.missingParameter());
                return true;
            }
            affectedPlayer = (EntityPlayer) cs;
        }
        
        if(arg[0].equals("clear"))
        {
            KajetansMod.chatManager.removeFakeRank(affectedPlayer);
            this.getModule().send(affectedPlayer, "Du hast keinen falschen Rang mehr.");
            if(!cs.equals(affectedPlayer))
            {
                this.getModule().send(cs, affectedPlayer.getName() + " hat keinen falschen Rang mehr.");
            }
            return true;
        }
        String rank = ChatManager.colorMessage(arg[0], cs);
        KajetansMod.chatManager.addFakeRank(affectedPlayer, rank);
        this.getModule().send(affectedPlayer, "Du hast nun den falschen Rang '" + rank + "§r'.");
        if(!cs.equals(affectedPlayer))
        {
            this.getModule().send(cs, affectedPlayer.getName() + " hat nun den falschen Rang '" + rank + "§r'.");
        }
        return true;
    }
}
