package me.km.commands;

import com.mojang.authlib.GameProfile;
import java.util.UUID;
import me.km.KajetansMod;
import me.km.api.Module;
import me.km.api.ModuleCommand;
import me.km.permissions.Permissions;
import net.minecraft.command.ICommandSender;

public class CommandAddUser extends ModuleCommand
{
    public CommandAddUser(Module m) 
    {
        super("adduser", m);
        super.setDescription("Fügt einen Spieler der Datenbank hinzu");
        super.setUsage("/adduser <uuid>");
        super.setPermission(Permissions.ADD_USER);
    }

    @Override
    public boolean execute(ICommandSender cs, String[] arg) 
    {
        if(arg.length < 1)
        {
            return false;
        }
        GameProfile op;
        try
        {
            op = KajetansMod.server.getPlayerProfileCache().getProfileByUUID(UUID.fromString(arg[0]));
        } 
        catch(IllegalArgumentException ex)
        {
            this.getModule().send(cs, "Das ist keine gültige UUID.");
            return true;
        }
        if(op == null)
        {
            this.getModule().send(cs, "Das ist kein gültiger Spieler");
            return true;
        }
        if(KajetansMod.playerbank.getDataBank().add(op))
        {
            this.getModule().send(cs, op.getName() + " wurde hinzugefügt.");
            return true;
        }
        this.getModule().send(cs, op.getName() + " ist schon in der Datenbank.");
        return true;
    }
}
