package me.km.commands;

import java.util.HashMap;
import me.km.KajetansMod;
import me.km.api.Module;
import me.km.api.ModuleCommand;
import me.km.api.Utils;
import me.km.chatmanager.ChatManager;
import me.km.exception.PlayerNotFoundException;
import me.km.permissions.Permissions;
import net.minecraft.command.ICommandSender;
import net.minecraft.util.text.TextComponentString;

public class CommandAnswer extends ModuleCommand
{
    public CommandAnswer(Module m) 
    {
        super("answer", m);
        super.setDescription("Schreibt dem letzten Spieler eine Privatnachricht");
        super.setUsage("/answer <message>");
        super.setPermission(Permissions.MSG);
        super.addAlias("r");
    }

    @Override
    public boolean execute(ICommandSender cs, String[] arg) 
    {
        if(arg.length == 0)
        {
            return false;
        }
        HashMap<String, String> answer = KajetansMod.generalCommands.getCommand(CommandMsg.class).answer;
        String s = answer.get(cs.getName());
        if(s == null)
        {
            this.getModule().send(cs, "Du hast niemanden, dem du antworten könntest.");
            return true;
        }
        ICommandSender previous;
        if(s.equals("CONSOLE"))
        {
            previous = KajetansMod.server;
        }
        else
        {
            try
            {
                previous = Utils.getPlayerByName(s);            
            }
            catch(PlayerNotFoundException ex)
            {
                this.getModule().send(cs, "Du hast niemanden, dem du antworten könntest.");
                return true;
            }
        }
        
        String message = ChatManager.colorMessage(Utils.connectSpaces(arg, 0), cs);
        cs.sendMessage(new TextComponentString("§6[ -> §c" + previous.getName()+ "§6] §r" + message));
        previous.sendMessage(new TextComponentString("§6[§c" + cs.getName()+ "§6] §r" + message));
        answer.put(cs.getName(), previous.getName());
        answer.put(previous.getName(), cs.getName());
        return true;  
    }
}
