package me.km.commands;

import me.km.api.GlobalText;
import me.km.api.Module;
import me.km.api.ModuleCommand;
import me.km.api.Utils;
import me.km.chatmanager.ChatManager;
import me.km.permissions.Permissions;
import net.minecraft.command.ICommandSender;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.init.Items;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;

public class CommandBook extends ModuleCommand
{
    public CommandBook(Module m) 
    {
        super("book", m);
        super.setDescription("Diverse Befehle für Bücher");
        super.setUsage("/book für die Hilfe");
        super.setPermission(Permissions.BOOK);
    }

    @Override
    public boolean execute(ICommandSender cs, String[] arg) 
    {
        if(!(cs instanceof EntityPlayer))
        {
            this.getModule().send(cs, GlobalText.onlyPlayer());
            return true;
        }
        Module m = this.getModule();
        EntityPlayer p = (EntityPlayer) cs;
        
        if(arg.length >= 1)
        {
            ItemStack stack = p.getHeldItemMainhand();
            if(stack.getItem() != Items.WRITTEN_BOOK)
            {
                m.send(cs, "Du hast kein signiertes Buch in der Hand.");
                return true;
            }
            NBTTagCompound com = stack.getTagCompound();
            if(com == null)
            {
                m.send(cs, GlobalText.shouldNotHappen());
                return true;
            }
            try
            {
                switch(arg[0])
                {
                    case "open":
                    {
                        ItemStack newItem = new ItemStack(Items.WRITABLE_BOOK);
                        NBTTagCompound pages = newItem.getTagCompound();
                        if(pages == null)
                        {
                            pages = new NBTTagCompound();
                        }
                        pages.setTag("pages", com.getTagList("pages", 8).copy());
                        newItem.setTagCompound(pages);
                        p.entityDropItem(newItem, 0);
                        return true;
                    }
                    case "author":
                    {       
                        com.setString("author", ChatManager.colorMessage(Utils.connectSpaces(arg, 1), p));
                        m.send(cs, "Der neue Autor wurde gesetzt.");
                        return true;
                    }
                    case "title":
                    {       
                        com.setString("title", ChatManager.colorMessage(Utils.connectSpaces(arg, 1), p));
                        m.send(cs, "Der neue Autor wurde gesetzt.");
                        return true;
                    }
                }
            }
            catch(Exception ex)
            {
                m.send(cs, "Unerwarteter Fehler: " + ex + " - " + ex.getMessage());
            }
        }
        
        m.send(cs, "/book ...");
        m.sendHelpListElement(cs, "open", "Öffnet dein Buch erneut");
        m.sendHelpListElement(cs, "author <name>", "Setzt den Autor des Buches");    
        m.sendHelpListElement(cs, "title <name>", "Setzt den Titel des Buches");    
        return true;
    }
}
