package me.km.commands;

import me.km.api.Utils;
import me.km.api.GlobalText;
import me.km.api.Module;
import me.km.api.ModuleCommand;
import me.km.exception.PlayerNotFoundException;
import me.km.permissions.Permissions;
import net.minecraft.command.ICommandSender;
import net.minecraft.entity.player.EntityPlayer;

public class CommandEnderChest extends ModuleCommand
{
    public CommandEnderChest(Module m) 
    {
        super("enderchest", m);
        super.setDescription("Zeigt dir die Enderchest eines Spielers");
        super.setUsage("/enderchest [player]");
        super.setPermission(Permissions.ENDERCHEST);
    }

    @Override
    public boolean execute(ICommandSender cs, String[] arg) 
    {
        if(!(cs instanceof EntityPlayer))
        {
            this.getModule().send(cs, GlobalText.onlyPlayer());
            return true;
        }
        EntityPlayer p = (EntityPlayer) cs;
        try
        {
            p.displayGUIChest(Utils.getPlayerByName(arg[0]).getInventoryEnderChest());
        }
        catch(PlayerNotFoundException ex)
        {
            this.getModule().send(cs, GlobalText.cantFindPlayer(arg[0]));
        }
        catch(IndexOutOfBoundsException ex)
        {
            p.displayGUIChest(p.getInventoryEnderChest());
        }
        return true;
    }
}
