package me.km.commands;

import me.km.api.Utils;
import me.km.api.GlobalText;
import me.km.api.Module;
import me.km.api.ModuleCommand;
import me.km.exception.PlayerNotFoundException;
import me.km.permissions.Permissions;
import net.minecraft.command.ICommandSender;
import net.minecraft.entity.player.EntityPlayer;

public class CommandFeed extends ModuleCommand
{
    public CommandFeed(Module m) 
    {
        super("feed", m);
        super.setDescription("Sättigt den Hunger eines Spielers");
        super.setUsage("/feed [player]");
        super.setPermission(Permissions.FEED);
    }

    @Override
    public boolean execute(ICommandSender cs, String[] arg) 
    {
        EntityPlayer affectedPlayer;
        Module m = this.getModule();
        try
        {
            affectedPlayer = Utils.getPlayerByName(arg[0]);    
            m.send(cs, "Der Hunger von " + affectedPlayer.getName() + " wurde gesättigt.");
            m.send(affectedPlayer, "Dein Hunger wurde gesättigt.");
        }
        catch(PlayerNotFoundException ex)
        {
            m.send(cs, GlobalText.cantFindPlayer(arg[0]));
            return true;
        }
        catch(IndexOutOfBoundsException ex)
        {
            if(!(cs instanceof EntityPlayer))
            {
                m.send(cs, GlobalText.missingParameter());
                return true;
            }     
            affectedPlayer = (EntityPlayer) cs;
            m.send(affectedPlayer, "Dein Hunger wurde gesättigt.");
        }
        affectedPlayer.getFoodStats().addStats(50, 1);
        return true;
    }
}
