package me.km.commands;

import me.km.KajetansMod;
import me.km.api.Utils;
import me.km.api.GlobalText;
import me.km.api.Module;
import me.km.api.ModuleCommand;
import me.km.playerbank.PlayerBank;
import me.km.exception.PlayerNotFoundException;
import me.km.permissions.Permissions;
import net.minecraft.command.ICommandSender;
import net.minecraft.entity.player.EntityPlayer;

public class CommandGod extends ModuleCommand
{
    public CommandGod(Module m) 
    {
        super("god", m);
        super.setDescription("Setzt einen Spieler auf God-Mode");
        super.setUsage("/god [player]");
        super.setPermission(Permissions.GOD);
    }

    @Override
    public boolean execute(ICommandSender cs, String[] arg) 
    {
        EntityPlayer affectedPlayer;
        try
        {
            affectedPlayer = Utils.getPlayerByName(arg[0]);    
        }
        catch(PlayerNotFoundException ex)
        {
            this.getModule().send(cs, GlobalText.cantFindPlayer(arg[0]));
            return true;
        }
        catch(IndexOutOfBoundsException ex)
        {
            if(!(cs instanceof EntityPlayer))
            {
                this.getModule().send(cs, GlobalText.missingParameter());
                return true;
            }     
            affectedPlayer = (EntityPlayer) cs;
        }
        
        PlayerBank pb = KajetansMod.playerbank.getDataBank();
        if(pb.getTag(affectedPlayer, "god") == 1)
        {
            pb.setTag(affectedPlayer, "god", 0);
            this.getModule().send(affectedPlayer, "Du bist nicht mehr unsterblich.");
            if(!affectedPlayer.equals(cs))
            {
                this.getModule().send(cs, affectedPlayer.getName() + " ist nicht mehr unsterblich.");
            }
            return true;
        }
        pb.setTag(affectedPlayer, "god", 1);
        this.getModule().send(affectedPlayer, "Du bist nun unsterblich.");
        if(!affectedPlayer.equals(cs))
        {
            this.getModule().send(cs, affectedPlayer.getName() + " ist nun unsterblich.");
        }
        return true;
    }
}
