package me.km.commands;

import me.km.api.GlobalText;
import me.km.api.Location;
import me.km.api.Module;
import me.km.api.ModuleCommand;
import me.km.permissions.Permissions;
import net.minecraft.block.BlockCrops;
import net.minecraft.block.state.IBlockState;
import net.minecraft.command.ICommandSender;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;

public class CommandGrow extends ModuleCommand
{
    public CommandGrow(Module m) 
    {
        super("grow", m);
        super.setDescription("Lässt die Pflanzen in deiner Umgebung wachsen");
        super.setUsage("/grow");
        super.setPermission(Permissions.GROW);
    }

    @Override
    public boolean execute(ICommandSender cs, String[] arg) 
    {
        if(!(cs instanceof EntityPlayer))
        {
            this.getModule().send(cs, GlobalText.onlyPlayer());
            return true;
        }
        EntityPlayer p = (EntityPlayer) cs;
        World w = p.world;
        BlockPos pos = p.getPosition();
        BlockPos relative;
        IBlockState state;
        for(int x = -3; x < 4; x++)
        {
            for(int y = -3; y < 4; y++)
            {
                for(int z = -3; z < 4; z++)
                {
                    relative = pos.add(x, y, z);
                    state = w.getBlockState(relative);
                    if(state.getBlock() instanceof BlockCrops)
                    {
                        w.setBlockState(relative, state.withProperty(BlockCrops.AGE, 7));                
                    }                      
                }
            }
        }
        this.getModule().send(cs, "Die Pflanzen in deiner Umgebung sind gewachsen.");
        return true;
    }
}
