package me.km.commands;

import me.km.api.Utils;
import me.km.api.GlobalText;
import me.km.api.Module;
import me.km.api.ModuleCommand;
import me.km.exception.PlayerNotFoundException;
import me.km.permissions.Permissions;
import net.minecraft.command.ICommandSender;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.potion.PotionEffect;

public class CommandHeal extends ModuleCommand
{
    public CommandHeal(Module m) 
    {
        super("heal", m);
        super.setDescription("Heilt einen Spieler");
        super.setUsage("/heal [player]");
        super.setPermission(Permissions.HEAL);
    }

    @Override
    public boolean execute(ICommandSender cs, String[] arg) 
    {
        EntityPlayer affectedPlayer;
        Module m = this.getModule();
        try
        {
            affectedPlayer = Utils.getPlayerByName(arg[0]);    
            m.send(cs, affectedPlayer.getName() + " wurde geheilt.");
            m.send(affectedPlayer, "Du wurdest geheilt.");
        }
        catch(PlayerNotFoundException ex)
        {
            m.send(cs, GlobalText.cantFindPlayer(arg[0]));
            return true;
        }
        catch(IndexOutOfBoundsException ex)
        {
            if(!(cs instanceof EntityPlayer))
            {
                m.send(cs, GlobalText.missingParameter());
                return true;
            }     
            affectedPlayer = (EntityPlayer) cs;
            m.send(affectedPlayer, "Du wurdest geheilt.");
        }
        affectedPlayer.setHealth(affectedPlayer.getMaxHealth());
        affectedPlayer.clearActivePotions();
        return true;
    }
}
