package me.km.commands;

import me.km.api.GlobalText;
import me.km.api.Module;
import me.km.api.ModuleCommand;
import me.km.permissions.Permissions;
import net.minecraft.command.ICommandSender;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.util.math.BlockPos;

public class CommandPosition extends ModuleCommand
{
    public CommandPosition(Module m) 
    {
        super("position", m);
        super.setDescription("Zeigt deine Position an");
        super.setUsage("/position");
        super.setPermission(Permissions.POSITION);
        super.addAlias("pos");
        super.addAlias("whereami");
    }

    @Override
    public boolean execute(ICommandSender cs, String[] arg) 
    {
        if(!(cs instanceof EntityPlayer))
        {
            this.getModule().send(cs, GlobalText.onlyPlayer());
            return true;
        }
        EntityPlayer p = (EntityPlayer) cs;
        Module m = this.getModule();
        m.send(cs, "Welt: " + p.getEntityWorld().getWorldInfo().getWorldName());
        BlockPos l = p.getPosition();
        m.send(cs, "Koordinaten: " + l.getX() + " | " + l.getY() + " | " + l.getZ());
        m.send(cs, "Yaw: " + p.rotationYaw);
        m.send(cs, "Pitch: " + p.rotationPitch);
        return true;
    }
}
