package me.km.commands;

import java.util.ArrayList;
import me.km.api.GlobalText;
import me.km.api.Module;
import java.util.stream.Collectors;
import me.km.api.ModuleTabCommand;
import me.km.permissions.Permissions;
import net.minecraft.command.ICommandSender;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.init.Items;
import net.minecraft.item.ItemStack;
import net.minecraft.potion.Potion;
import net.minecraft.potion.PotionEffect;
import net.minecraft.potion.PotionUtils;

public class CommandPotion extends ModuleTabCommand
{
    public CommandPotion(Module m) 
    {
        super("potion", m, Potion.REGISTRY.getKeys().stream().map(r -> r.getResourcePath()).collect(Collectors.toList()), 0); 
        super.setDescription("Erzeugt Custom-Potions");
        super.setUsage("/potion [effect] [duration] [amplifier]");
        super.setPermission(Permissions.POTION);
    }

    @Override
    public boolean execute(ICommandSender cs, String[] arg) 
    {
        if(!(cs instanceof EntityPlayer))
        {
            this.getModule().send(cs, GlobalText.onlyPlayer());
            return true;
        }
        EntityPlayer p = (EntityPlayer) cs;
        ItemStack hand = p.getHeldItemMainhand();
        if(hand.getItem() != Items.SPLASH_POTION &&
           hand.getItem() != Items.POTIONITEM &&
           hand.getItem() != Items.LINGERING_POTION)
        {
            this.getModule().send(cs, "Du musst einen Trank in der Hand halten.");
            return true;
        }
        if(arg.length < 1)
        {
            return false;
        }

        try
        {
            ArrayList<PotionEffect> list = new ArrayList<>();
            list.add(new PotionEffect(Potion.getPotionFromResourceLocation(arg[0]), Integer.parseInt(arg[1]), Integer.parseInt(arg[2])));
            PotionUtils.appendEffects(hand, list);
            this.getModule().send(cs, "Der Effekt wurde hinzugefügt.");
        }
        catch(NumberFormatException ex)
        {
            this.getModule().send(cs, GlobalText.noIntegerNumber());
            return true;
        }
        catch(NullPointerException ex)
        {
            this.getModule().send(cs, "Der gegebene Potion-Effect existiert nicht.");
            return true;
        }
        catch(ArrayIndexOutOfBoundsException ex)
        {
            return false;
        }
        return true;
    }
}
