package me.km.commands;

import me.km.api.GlobalText;
import me.km.api.Module;
import me.km.api.ModuleCommand;
import me.km.permissions.Permissions;
import net.minecraft.command.ICommandSender;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemStack;

public class CommandRepair extends ModuleCommand
{
    public CommandRepair(Module m) 
    {
        super("repair", m);
        super.setDescription("Repariert ein Item");
        super.setUsage("/repair");
        super.setPermission(Permissions.REPAIR);
    }

    @Override
    public boolean execute(ICommandSender cs, String[] arg) 
    {
        if(!(cs instanceof EntityPlayer))
        {
            this.getModule().send(cs, GlobalText.onlyPlayer());
            return true;
        }
        ItemStack stack = ((EntityPlayer) cs).getHeldItemMainhand();
        if(stack == null || stack == ItemStack.EMPTY)
        {
            this.getModule().send(cs, "Du musst ein Item in der Hand halten.");
            return true;
        }
        if(stack.getItemDamage() != 0)
        {
            stack.setItemDamage(0);
        }
        this.getModule().send(cs, "Das Item wurde repariert.");
        return true;
    }
}
