package me.km.commands;

import java.io.File;
import me.km.KajetansMod;
import me.km.api.Utils;
import me.km.api.Module;
import me.km.api.ModuleCommand;
import me.km.exception.PlayerNotFoundException;
import java.text.SimpleDateFormat;
import java.util.Date;
import me.km.permissions.Permissions;
import net.minecraft.command.ICommandSender;
import net.minecraft.entity.player.EntityPlayer;

public class CommandSeen extends ModuleCommand
{
    public CommandSeen(Module m) 
    {
        super("seen", m);
        super.setDescription("Zeigt wann ein Spieler zuletzt online war");
        super.setUsage("/seen <player>");
        super.setPermission(Permissions.SEEN);
    }

    @Override
    public boolean execute(ICommandSender cs, String[] arg) 
    {
        try
        {
            EntityPlayer p = Utils.getPlayerByName(arg[0]);  
            this.getModule().send(cs, p.getName() + " ist gerade online.");
            return true;
        }
        catch(PlayerNotFoundException ex)
        {
            String uuid = KajetansMod.playerbank.getDataBank().getUUID(arg[0]);
            if(uuid == null)
            {
                this.getModule().send(cs, arg[0] + " war noch nie auf dem Server.");
                return true;
            }
            File f = new File("./saves/world/playerdata/" + uuid + ".dat"); 
            if(!f.exists())
            {
                this.getModule().send(cs, "Die Spielerdaten wurden nicht gefunden.");
                return true;
            }
            Date date = new Date(f.lastModified());
            SimpleDateFormat ft = new SimpleDateFormat ("dd.MM.yyyy 'um' HH:mm:ss");
            this.getModule().send(cs, arg[0] + " war zuletzt am " + ft.format(date) + " online.");
            return true;
        }
        catch(IndexOutOfBoundsException ex)
        {
            return false;
        }
    }
}
