package me.km.commands;

import me.km.api.GlobalText;
import me.km.api.Location;
import me.km.api.Module;
import me.km.api.ModuleCommand;
import me.km.api.Utils;
import me.km.exception.PlayerNotFoundException;
import me.km.permissions.Permissions;
import net.minecraft.command.ICommandSender;
import net.minecraft.entity.player.EntityPlayer;

public class CommandSpawn extends ModuleCommand
{
    public CommandSpawn(Module m) 
    {
        super("spawn", m);
        super.setDescription("Teleportiert einen Spieler zum Spawn.");
        super.setUsage("/spawn [player]");
        super.setPermission(Permissions.SPAWN);
    }

    @Override
    public boolean execute(ICommandSender cs, String[] arg) 
    {
        EntityPlayer affectedPlayer;
        try
        {
            affectedPlayer = Utils.getPlayerByName(arg[0]);    
            this.getModule().send(affectedPlayer, "Du wurdest zum Spawn teleportiert.");
            this.getModule().send(cs, affectedPlayer.getName() + " wurde zum Spawn teleportiert.");
        }
        catch(PlayerNotFoundException ex)
        {
            this.getModule().send(cs, GlobalText.cantFindPlayer(arg[0]));
            return true;
        }
        catch(IndexOutOfBoundsException ex)
        {
            if(!(cs instanceof EntityPlayer))
            {
                this.getModule().send(cs, GlobalText.missingParameter());
                return true;
            }     
            affectedPlayer = (EntityPlayer) cs;
            this.getModule().send(affectedPlayer, "Du wurdest zum Spawn teleportiert.");
        }
        Location l = Utils.getSpawn();
        if(l == null)
        {
            this.getModule().send(affectedPlayer, "Es wurde kein Spawn gesetzt.");
        }
        else if(l.getWorld() == null)
        {
            this.getModule().send(affectedPlayer, "Die Welt des Spawns existiert nicht.");
        }
        Utils.teleportEntity(affectedPlayer, l);
        return true;
    }
}
