package me.km.commands;

import me.km.api.GlobalText;
import me.km.api.Module;
import me.km.api.ModuleCommand;
import java.util.HashMap;
import java.util.UUID;
import me.km.KajetansMod;
import me.km.api.Utils;
import me.km.permissions.Permissions;
import net.minecraft.command.ICommandSender;
import net.minecraft.entity.player.EntityPlayer;

public class CommandTeleportAccept extends ModuleCommand
{
    public HashMap<UUID, UUID> tpaccept;
    
    public CommandTeleportAccept(Module m) 
    {
        super("teleportaccept", m);
        super.setDescription("Akzeptiert eine Teleportanfrage");
        super.setUsage("/teleportaccept");
        super.setPermission(Permissions.TELEPORT_ACCEPT);
        super.addAlias("tpa");
        
        tpaccept = new HashMap<>();
    }

    @Override
    public boolean execute(ICommandSender cs, String[] arg) 
    {
        if(!(cs instanceof EntityPlayer))
        {
            this.getModule().send(cs, GlobalText.onlyPlayer());
            return true;
        }
        EntityPlayer p = (EntityPlayer) cs;
        if(!tpaccept.containsKey(p.getUniqueID()))
        {
            this.getModule().send(cs, "Du hast keine ausstehenden Teleportanfragen.");
            return true;
        }
        EntityPlayer affectedPlayer = KajetansMod.server.getPlayerList().getPlayerByUUID(tpaccept.get(p.getUniqueID()));
        if(affectedPlayer == null)
        {
            this.getModule().send(cs, "Der Spieler ist nicht mehr online.");
            tpaccept.remove(p.getUniqueID());
            return true;
        }            
        tpaccept.remove(p.getUniqueID());
        Utils.teleportEntity(affectedPlayer, p);
        this.getModule().send(affectedPlayer, "Du wurdest zu " + p.getName() + " teleportiert.");
        this.getModule().send(p, affectedPlayer.getName() + " hat sich zu dir teleportiert.");
        return true;
    }
}
