package me.km.commands;

import me.km.api.GlobalText;
import me.km.api.Module;
import me.km.api.ModuleCommand;
import me.km.permissions.Permissions;
import net.minecraft.command.ICommandSender;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.world.World;

public class CommandTime extends ModuleCommand
{
    public CommandTime(Module m) 
    {
        super("time", m);
        super.setDescription("Setzt die Tageszeit in einer Welt");
        super.setUsage("/time <day|night|ticks_as_number>");
        super.setPermission(Permissions.TIME);
    }

    @Override
    public boolean execute(ICommandSender cs, String[] arg) 
    {
        if(arg.length == 0)
        {
            return false;
        }
        
        World w = ((EntityPlayer) cs).getEntityWorld();
        if(arg[0].equals("day"))
        {
            w.setWorldTime(0);
            this.getModule().send(cs, "Die Tageszeit wurde auf 0 gesetzt.");
            return true;
        }
        else if(arg[0].equals("night"))
        {
            w.setWorldTime(14000);
            this.getModule().send(cs, "Die Tageszeit wurde auf 14000 gesetzt.");
            return true;
        }
        try
        {
            int time = Integer.parseInt(arg[0]);
            if(time < 0)
            {
                this.getModule().send(cs, GlobalText.noNaturalNumber());
                return true;
            }
            w.setWorldTime(time);
            this.getModule().send(cs, "Die Tageszeit wurde auf " + arg[0] + " gesetzt.");
            return true;
        }
        catch(Exception ex)
        {
            this.getModule().send(cs, GlobalText.noNaturalNumber());
            return true;
        }
    }
}
