package me.km.dimensions;

import java.util.Random;
import me.km.blocks.ModBlocks;
import net.minecraft.block.state.IBlockState;
import net.minecraft.init.Biomes;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;
import net.minecraft.world.biome.Biome;
import net.minecraft.world.chunk.IChunkGenerator;
import net.minecraft.world.chunk.IChunkProvider;
import net.minecraft.world.gen.feature.WorldGenMinable;
import net.minecraftforge.fml.common.IWorldGenerator;

public class ModWorldGeneration implements IWorldGenerator
{
    @Override
    public void generate(Random random, int chunkX, int chunkZ, World w, 
            IChunkGenerator chunkGenerator, IChunkProvider chunkProvider) 
    {
        Biome biome = w.getBiome(BlockPos.ORIGIN);
        if(biome != Biomes.HELL && biome != Biomes.SKY) 
        {
            generateOverworld(random, chunkX, chunkZ, w, chunkGenerator, chunkProvider);
	}
    }
	
    private void generateOverworld(Random random, int chunkX, int chunkZ, World w, 
            IChunkGenerator chunkGenerator, IChunkProvider chunkProvider) 
    {
        generateOre(ModBlocks.copperOre.getDefaultState(), w, random, 
                chunkX << 4, chunkZ << 4, 0, 128, 20, 5);
        generateOre(ModBlocks.tinOre.getDefaultState(), w, random, 
                chunkX << 4, chunkZ << 4, 0, 96, 8, 3);
        generateOre(ModBlocks.tinOre.getDefaultState(), w, random, 
                chunkX << 4, chunkZ << 4, 0, 128, 16, 1);
    } 
    
    private void generateOre(IBlockState ore, World world, Random random, int x, int z, 
            int minY, int maxY, int size, int chances) 
    {
        int deltaY = maxY - minY;
        BlockPos pos;
        WorldGenMinable generator;
        for (int i = 0; i < chances; i++) 
        {
            // generates position in chunk
            pos = new BlockPos(x + random.nextInt(16), minY + random.nextInt(deltaY), z + random.nextInt(16));
            generator = new WorldGenMinable(ore, size);
            generator.generate(world, random, pos);
        }
    }
}
