package me.km.effects;

import net.minecraft.entity.player.EntityPlayer;

public class PlayerUsesEffectEvent
{
    private final EntityPlayer p;
    private int power;
    private int mana;
    private final EffectCause cause;
    private boolean cancel;
    private final String effect;

    public PlayerUsesEffectEvent(EntityPlayer p, int power, int mana, EffectCause cause, Class<? extends ActiveEffectBase> effect) 
    {
        this.p = p;
        this.power = power;
        this.mana = mana;
        this.cause = cause;
        this.cancel = false;
        this.effect = effect.getSimpleName();
    }
    
    public EntityPlayer getPlayer()
    {
        return p;
    }
    
    public int getPower()
    {
        return power;
    }
    
    public void setPower(int power)
    {
        this.power = power;
    }
    
    public int getMana()
    {
        return mana;
    }
    
    public void setMana(int mana)
    {
        this.mana = mana;
    }
    
    public EffectCause getCause()
    {
        return cause;
    }
    
    public String getEffect()
    {
        return effect;
    }
    
    public boolean isCanceled() 
    {
        return cancel;
    }

    public void setCanceled(boolean cancel) 
    {
        this.cancel = cancel;
    }
}
