package me.km.effects.active;

import me.km.effects.ActiveEffectBase;
import me.km.effects.EffectBlockChanger;
import me.km.effects.EffectUtils;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraft.init.Blocks;
import net.minecraft.init.MobEffects;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.WorldServer;

public class LeafCocoon extends ActiveEffectBase
{
    @Override
    public int getCoolDown() 
    {
        return 100;
    }
    
    @Override
    protected boolean executeEffect(EntityPlayerMP p, int power) 
    {
        EffectUtils.addPotionTo(p, MobEffects.RESISTANCE, power * 60, 4);
        EffectUtils.addPotionTo(p, MobEffects.REGENERATION, power * 20, 4);
        
        WorldServer w = p.getServerWorld();
        EffectBlockChanger list = new EffectBlockChanger(w);
        BlockPos l = p.getPosition();
        
        // Ebene 1
        list.addBlock(l.add(0, 0, -3), Blocks.LEAVES);
        list.addBlock(l.add(1, 0, -2), Blocks.LEAVES);
        list.addBlock(l.add(0, 0, -2), Blocks.LOG, 9);
        list.addBlock(l.add(-1, 0, -2), Blocks.LEAVES);
        list.addBlock(l.add(-2, 0, -2), Blocks.SPRUCE_FENCE);
        list.addBlock(l.add(2, 0, -1), Blocks.SPRUCE_FENCE);
        list.addBlock(l.add(1, 0, -1), Blocks.LEAVES);
        list.addBlock(l.add(0, 0, -1), Blocks.LEAVES);
        list.addBlock(l.add(-1, 0, -1), Blocks.LEAVES);
        list.addBlock(l.add(-2, 0, -1), Blocks.LEAVES);
        list.addBlock(l.add(2, 0, 0), Blocks.LEAVES);
        list.addBlock(l.add(1, 0, 0), Blocks.LEAVES);
        list.addBlock(l.add(-1, 0, 0), Blocks.LEAVES);
        list.addBlock(l.add(-2, 0, 0), Blocks.LEAVES);
        list.addBlock(l.add(2, 0, 1), Blocks.LEAVES);
        list.addBlock(l.add(1, 0, 1), Blocks.LEAVES);
        list.addBlock(l.add(0, 0, 1), Blocks.LEAVES);
        list.addBlock(l.add(-1, 0, 1), Blocks.LEAVES);
        list.addBlock(l.add(3, 0, 2), Blocks.OAK_FENCE);
        list.addBlock(l.add(2, 0, 2), Blocks.LOG, 9);
        list.addBlock(l.add(1, 0, 2), Blocks.LEAVES);
        list.addBlock(l.add(0, 0, 2), Blocks.LEAVES);
        list.addBlock(l.add(-1, 0, 2), Blocks.OAK_FENCE);
        list.addBlock(l.add(1, 0, 3), Blocks.LEAVES);
        
        // Ebene 2
        list.addBlock(l.add(0, 1, -2), Blocks.LOG, 1);
        list.addBlock(l.add(1, 1, -1), Blocks.LEAVES);
        list.addBlock(l.add(0, 1, -1), Blocks.LEAVES);
        list.addBlock(l.add(-1, 1, -1), Blocks.LEAVES);
        list.addBlock(l.add(2, 1, 0), Blocks.LOG, 1);
        list.addBlock(l.add(1, 1, 0), Blocks.LEAVES);
        list.addBlock(l.add(-1, 1, 0), Blocks.LEAVES);
        list.addBlock(l.add(-2, 1, 0), Blocks.LOG, 1);
        list.addBlock(l.add(1, 1, 1), Blocks.LEAVES);
        list.addBlock(l.add(0, 1, 1), Blocks.LEAVES);
        list.addBlock(l.add(0, 1, 2), Blocks.OAK_FENCE);
        
        // Ebene 3
        list.addBlock(l.add(0, 2, -1), Blocks.LEAVES);
        list.addBlock(l.add(-1, 2, -1), Blocks.LOG, 1);
        list.addBlock(l.add(1, 2, 0), Blocks.LEAVES);
        list.addBlock(l.add(0, 2, 0), Blocks.LEAVES);
        list.addBlock(l.add(-1, 2, 0), Blocks.LEAVES);
        list.addBlock(l.add(1, 2, 1), Blocks.OAK_FENCE);
        list.addBlock(l.add(0, 2, 1), Blocks.LOG, 1);
        
        // Ebene 4
        list.addBlock(l.add(0, 3, 1), Blocks.SPRUCE_FENCE);
        list.addBlock(l.add(0, 3, 0), Blocks.LEAVES);
        list.addBlock(l.add(0, 3, -1), Blocks.OAK_FENCE);
        
        list.run(160);
        return true;
    }

    @Override
    protected int getManaCost(int manaFactor) 
    {
        return 15 * manaFactor;
    }
}
