package me.km.effects.active;

import me.km.effects.ActiveEffectBase;
import me.km.effects.EffectUtils;
import me.km.entities.EntityItemProjectile;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraft.init.Blocks;
import net.minecraft.init.SoundEvents;
import net.minecraft.item.ItemStack;

public class Stone extends ActiveEffectBase
{
    @Override
    protected boolean executeEffect(EntityPlayerMP p, int power) 
    {
        EffectUtils.playSound(p, SoundEvents.ENTITY_ARROW_SHOOT);
        float spread = 1.2f - power * 0.06f;
        if(spread < 0)
        {
            spread = 0;
        }      
        EntityItemProjectile launch = new EntityItemProjectile(p, new ItemStack(Blocks.STONE), power * 2);
        launch.setHeadingFromThrower(p, p.rotationPitch, p.rotationYaw, 0, 0.9f, spread);
        p.world.spawnEntity(launch);
        return true;
    }
    
    @Override
    protected int getManaCost(int manaFactor) 
    {
        return 3 * manaFactor;
    }
}
