package me.km.environment;

import me.km.api.Utils;
import me.km.api.GlobalText;
import me.km.api.Module;
import me.km.api.ModuleCommand;
import me.km.exception.PlayerNotFoundException;
import me.km.permissions.Permissions;
import net.minecraft.command.ICommandSender;
import net.minecraft.entity.player.EntityPlayer;

public class CommandHealStats extends ModuleCommand
{
    public CommandHealStats(Module m) 
    {
        super("healstats", m);
        super.setDescription("Füllt die Zusatzstats eines Spielers");
        super.setUsage("/healstats [player]");
        super.setPermission(Permissions.HEAL_STATS);
        super.addAlias("heals");
    }

    @Override
    public boolean execute(ICommandSender cs, String[] arg) 
    {
        EntityPlayer affectedPlayer;
        Module m = this.getModule();
        try
        {
            affectedPlayer = Utils.getPlayerByName(arg[0]);    
            m.send(cs, "Die Stats von " + affectedPlayer.getName() + " wurden gefüllt.");
            m.send(affectedPlayer, "Deine Stats wurden gefüllt.");
        }
        catch(PlayerNotFoundException ex)
        {
            m.send(cs, GlobalText.cantFindPlayer(arg[0]));
            return true;
        }
        catch(IndexOutOfBoundsException ex)
        {
            if(!(cs instanceof EntityPlayer))
            {
                m.send(cs, GlobalText.missingParameter());
                return true;
            }     
            affectedPlayer = (EntityPlayer) cs;
            m.send(affectedPlayer, "Deine Stats wurden gefüllt.");
        }
        EnvironmentAPI.resetThirst(affectedPlayer);
        EnvironmentAPI.resetEnergy(affectedPlayer);
        EnvironmentAPI.resetCold(affectedPlayer);
        EnvironmentAPI.resetMana(affectedPlayer);
        return true;
    }
}

