package me.km.environment;

import java.util.Arrays;
import me.km.KajetansMod;
import me.km.effects.Effect;
import me.km.effects.EffectUtils;
import net.minecraft.init.MobEffects;
import net.minecraft.util.DamageSource;

public class EnvironmentTick implements Runnable
{
    @Override
    public void run() 
    {        
        Arrays.stream(KajetansMod.server.worlds).filter(w -> KajetansMod.worldManager.getWorldPreferences(w).statusEffects).forEach(w -> 
            {
                w.playerEntities.stream()
                        .filter(p -> !(p.isCreative() || p.isSpectator()))
                        .forEach(p -> 
                {
                    int i = -12;
                    float damage = 0;
                    // Durst    
                    if(p.isInWater())
                    {
                        if(p.isSprinting())
                        {
                            i -= 12;
                        }
                        EnvironmentAPI.changeThirst(p, i);
                        if(EnvironmentAPI.getThirst(p) <= 1000)
                        {
                            damage += 0.5;
                        }
                    }
                    else
                    {
                        EnvironmentAPI.resetThirst(p);
                    }

                    // Energie
                    i = -6;
                    if(p.isSprinting())
                    {
                        i -= 6; 
                    } 
                    EnvironmentAPI.changeEnergy(p, i);    
                    int energy = EnvironmentAPI.getEnergy(p) - 3000;
                    if(energy < 0)
                    {                
                        energy /= -1000;
                        EffectUtils.addPotionTo(p, MobEffects.SLOWNESS, 800, energy);
                        EffectUtils.addPotionTo(p, MobEffects.MINING_FATIGUE, 800, energy);
                        EffectUtils.addPotionTo(p, MobEffects.WEAKNESS, 800, energy);
                    }

                    // Kälte
                    i = EnvironmentAPI.getTemperature(w, p.getPosition());
                    i = (i - 10) / 2;
                    //System.out.println(p.getName() + "  " + i);
                    EnvironmentAPI.changeCold(p, i);

                    if(EnvironmentAPI.getCold(p) <= 10)
                    {
                        damage += 0.5;
                    }
                    if(damage != 0)
                    {
                        p.attackEntityFrom(DamageSource.WITHER, damage);
                    }
                    
                    // Hunger
                    int hunger = EffectUtils.getEffectLevel(p, Effect.LESS_HUNGER);
                    if(hunger > 0)
                    {
                        float f = p.getFoodStats().getSaturationLevel();
                        f += hunger / 16f;
                        if(f < 15)
                        {
                            p.getFoodStats().setFoodSaturationLevel(f);
                        }
                    }
                });
            });   
        
        Arrays.stream(KajetansMod.server.worlds).filter(w -> KajetansMod.worldManager.getWorldPreferences(w).statusEffects).forEach(w -> 
            {
                w.playerEntities.stream()
                        .filter(p -> !(p.isCreative() || p.isSpectator()))
                        .forEach(p -> 
                {
                    // Mana
                    EnvironmentAPI.changeMana(p, 6);
                });
            });
    }
}
