package me.km.events;

import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.util.math.Vec3d;
import net.minecraft.world.WorldServer;
import net.minecraftforge.event.entity.player.PlayerEvent;

public class PlayerRespawnAtEvent extends PlayerEvent
{
    private WorldServer w;
    private Vec3d v;
    private boolean force;
    private boolean forceKeepInventory;
    
    public PlayerRespawnAtEvent(EntityPlayer player, WorldServer w, double x, double y, double z) 
    {
        super(player);
        this.w = w;
        this.v = new Vec3d(x, y, z);
        this.force = false;
        this.forceKeepInventory = false;
    }
    
    public WorldServer getWorld()
    {
        return w;
    }
    
    public void setWorld(WorldServer w)
    {
        if(this.w != w)
        {
            this.force = true;
        }
        this.w = w;
    }
    
    public Vec3d getRespawnLoc()
    {
        return v;
    }
    
    public void setRespawnLoc(Vec3d v)
    {
        if(this.v != v)
        {
            this.force = true;
        }
        this.v = v;
    }
    
    public boolean isForced()
    {
        return force;
    }
    
    public void setForcedInventoryKeeping(boolean b)
    {
        this.forceKeepInventory = b;
    }
    
    public boolean isInventoryKeepingForced()
    {
        return forceKeepInventory;
    }
}
