package me.km.inventory;

import net.minecraft.entity.Entity;
import net.minecraft.inventory.InventoryBasic;
import net.minecraft.item.ItemStack;

public class EntityInventory extends InventoryBasic
{
    private final Entity ent;
    
    public EntityInventory(String title, int slotCount, Entity ent) 
    {
        super(title, true, slotCount);
        this.ent = ent;
    }
    
    public Entity getEntity()
    {
        return ent;
    }
    
    public void setContents(Iterable<? extends ItemStack> stacks)
    {
        int counter = 0;
        int size = super.getSizeInventory();
        for(ItemStack stack : stacks)
        {
            this.setInventorySlotContents(counter, stack);
            counter++;
            if(counter >= size)
            {
                return;
            }
        }
    }
}
