package me.km.inventory;

import java.util.HashMap;
import java.util.List;
import java.util.UUID;
import me.km.KajetansMod;
import me.km.api.Module;
import me.km.api.Utils;
import me.km.commands.CommandTeleportAccept;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraft.inventory.ClickType;
import net.minecraft.inventory.InventoryBasic;

public class TeleportContainer extends CustomContainer
{
    private final List<EntityPlayer> players;
    
    public TeleportContainer(EntityPlayerMP p, List<EntityPlayer> list) 
    {
        super("Teleport to Player ...", list.size() % 9 == 0 ? list.size() : ((list.size() / 9) + 1) * 9, p);
        this.players = list;
        this.players.remove(p);
        
        InventoryBasic inv = super.getShownInventory();
        int counter = 0;
        for(EntityPlayer player : players) 
        {
            inv.setInventorySlotContents(counter, Utils.getPlayerHead(player).setStackDisplayName("§6" + player.getName()));
            counter++;
        }     
    }

    @Override
    public void onCanceledClick(int slotId, int dragType, ClickType clickTypeIn, EntityPlayerMP p) 
    {
        if(slotId >= players.size())
        {
            return;
        }
        Module m = KajetansMod.effects;
        EntityPlayer p2 = players.get(slotId);
        m.send(p, "Die Anfrage wurde an '" + p2.getName() + "' geschickt.");
        m.send(p2, p.getName() + " möchte sich zu dir teleportieren.");
        m.send(p2, "Du kannst mit /tpa akzeptieren.");
        HashMap<UUID, UUID> tpaccept = KajetansMod.generalCommands.getCommand(CommandTeleportAccept.class).tpaccept;
        tpaccept.put(p2.getUniqueID(), p.getUniqueID());
        p.closeScreen();
    }
}
