package me.km.items;

import me.km.KajetansMod;
import me.km.api.GlobalText;
import me.km.api.Utils;
import me.km.effects.ActiveEffectBase;
import me.km.effects.EffectCause;
import me.km.effects.EffectUtils;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraft.item.ItemStack;
import net.minecraft.stats.StatList;
import net.minecraft.util.ActionResult;
import net.minecraft.util.EnumActionResult;
import net.minecraft.util.EnumHand;
import net.minecraft.world.World;

public class ItemScroll extends ItemBase
{
    public ItemScroll(String name, String local) 
    {
        super(name, local);
    }

    @Override
    public ActionResult<ItemStack> onItemRightClick(World w, EntityPlayer p, EnumHand hand) 
    {
        if(w.isRemote)
        {
            return new ActionResult(EnumActionResult.FAIL, p.getHeldItem(hand));
        }
        
        if(!KajetansMod.worldManager.getWorldPreferences(w).scrolls)
        {
            KajetansMod.scrolls.send(p, GlobalText.noScrolls());
            return new ActionResult(EnumActionResult.FAIL, p.getHeldItem(hand));
        }
        
        ItemStack stack = p.getHeldItem(hand);
        String s = stack.getDisplayName();
        if(s.contains(" "))
        {
            try
            {
                String[] parts = s.split(" ");
                if(parts.length < 2)
                {
                    throw new Exception();
                }
                Class<? extends ActiveEffectBase> c = EffectUtils.getEffectClass(parts[0]);
                if(c == null)
                { 
                    throw new Exception();
                }
                int power = Utils.romanToInt(parts[1]);
                if(ActiveEffectBase.executeEffect(c, (EntityPlayerMP) p, power, 0, EffectCause.SCROLL))
                {
                    if(!p.isCreative())
                    {
                        stack.shrink(1);
                    }
                }
            }
            catch(Exception ex)
            {
                KajetansMod.scrolls.send(p, "Die Schriftrolle ist korrupt.");
                return new ActionResult(EnumActionResult.FAIL, stack);
            }
        }

        p.addStat(StatList.getObjectUseStats(this));
        return new ActionResult(EnumActionResult.SUCCESS, stack);
    }
}
