
package me.km.jobsystem;

import me.km.api.GlobalText;
import me.km.api.Module;
import me.km.api.ModuleCommand;
import me.km.api.Utils;
import me.km.exception.PlayerNotFoundException;
import me.km.permissions.Permissions;
import me.km.skills.SkillMenuUtilities;
import net.minecraft.command.ICommandSender;
import net.minecraft.entity.player.EntityPlayerMP;

public class CommandRecipe extends ModuleCommand
{   
    public CommandRecipe(Module m) 
    {
        super("recipe", m);
        super.setDescription("Zeigt deine Rezepte");
        super.setUsage("/recipe [player]");
        super.setPermission(Permissions.RECIPE);
        super.addAlias("recipes");
    }

    @Override
    public boolean execute(ICommandSender cs, String[] arg) 
    {
        if(!(cs instanceof EntityPlayerMP))
        {
            this.getModule().send(cs, GlobalText.onlyPlayer());
            return true;
        }
        EntityPlayerMP p = (EntityPlayerMP) cs;
        
        EntityPlayerMP affectedPlayer;
        try
        {
            affectedPlayer = Utils.getPlayerByName(arg[0]);    
        }
        catch(PlayerNotFoundException ex)
        {
            this.getModule().send(cs, GlobalText.cantFindPlayer(arg[0]));
            return true;
        }
        catch(IndexOutOfBoundsException ex)
        {
            if(!(cs instanceof EntityPlayerMP))
            {
                this.getModule().send(cs, GlobalText.missingParameter());
                return true;
            }     
            affectedPlayer = (EntityPlayerMP) cs;
        }
        SkillMenuUtilities.openRecipes(affectedPlayer, p);
        return true;
    }
}
