package me.km.playerbank;

import java.util.HashMap;
import me.km.KajetansMod;
import me.km.scoreboard.PlayerScoreboard;
import net.minecraft.entity.player.EntityPlayerMP;

public class PlayerData
{
    private class DataContainer
    {
        protected int taskId;
        protected Object o;
        protected int entry;
        
        public DataContainer(int taskId, Object o, int entry)
        {
            this.taskId = taskId;
            this.o = o;
            this.entry = entry;
        }
    }
    
    private final HashMap<String, DataContainer> data;
    private final PlayerScoreboard sb;
    
    public PlayerData(EntityPlayerMP p)
    {
        data = new HashMap<>();
        sb = KajetansMod.scoreboard.getScoreboard(p);
    }
    
    public boolean removeData(String s)
    {
        DataContainer d = data.remove(s);
        if(d != null)
        {
            if(d.entry != -1)
            {
                sb.removeText(d.entry);
            }
            if(d.taskId != -1)
            {
                KajetansMod.scheduler.cancelTask(d.taskId);
            }
            return true;
        }
        return false;
    }
    
    private void addTimedData(String s, Object o, int ticks, String text, int id)
    {
        if(id != -1 && text != null)
        {
            sb.addText(id, text);
        }
        data.put(s, new DataContainer(KajetansMod.scheduler.scheduleTask(() -> removeData(s), ticks), o, id));
    }
    
    public void addGoodTimedData(String s, Object o, int ticks, String text, int id)
    {
        addTimedData(s, o, ticks, "§2" + text, id);
    }
    
    public void addBadTimedData(String s, Object o, int ticks, String text, int id)
    {
        addTimedData(s, o, ticks, "§4" + text, id);
    }
    
    public void addTimedData(String s, Object o, int ticks)
    {
        addTimedData(s, o, ticks, null, -1);
    }
    
    public void addTimedData(String s, int ticks)
    {
        addTimedData(s, 0, ticks);
    }
    
    private void addData(String s, Object o, String text, int id)
    {
        if(id != -1 && text != null)
        {
            sb.addText(id, text);
        }
        data.put(s, new DataContainer(-1, o, id));
    }
    
    public void addGoodData(String s, Object o, String text, int id)
    {
        addData(s, o, "§2" + text, id);
    }
    
    public void addBadData(String s, Object o, String text, int id)
    {
        addData(s, o, "§4" + text, id);
    }
    
    public void addData(String s, Object o)
    {
        addData(s, o, null, -1);
    }
    
    public void addData(String s)
    {
        addData(s, 0);
    }
    
    public boolean hasData(String s)
    {
        return data.containsKey(s);
    }

    public <T> T getData(String s, Class<T> c)
    {
        try
        {
            return (T) data.get(s).o;
        }
        catch(NullPointerException | ClassCastException ex)
        {
            return null;
        }
    }
    
    public double getDouble(String s)
    {
        Number d = getData(s, Number.class);
        return d == null ? 0 : d.doubleValue();
    }
    
}
