package me.km.playerbank;

import java.util.HashMap;
import java.util.UUID;
import me.km.api.Location;
import me.km.api.Module;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraft.util.text.TextFormatting;

public class PlayerManager extends Module
{
    private final HashMap<UUID, PlayerData> data;
    private final HashMap<UUID, Location> back;
    
    public PlayerManager(String mname, String prefix, TextFormatting color) 
    {
        super(mname, prefix, color);
        data = new HashMap<>();
        back = new HashMap<>();
    }

    public PlayerBank getDataBank() 
    {
        return super.getDataBank(PlayerBank.class);
    }
    
    public Location saveLocation(EntityPlayer p)
    {
        return back.put(p.getUniqueID(), new Location(p.world, p.getPositionVector()));
    }
    
    public Location getLastLocation(EntityPlayer p)
    {
        return back.get(p.getUniqueID());
    }
    
    public PlayerData getData(EntityPlayerMP p)
    {
        PlayerData pd = data.get(p.getUniqueID());
        if(pd == null)
        {
            pd = new PlayerData(p);
            data.put(p.getUniqueID(), pd);
            return pd;
        }
        return pd;
    }
    
    public void removeData(EntityPlayer p)
    {
        data.remove(p.getUniqueID());
    }
    
    public int getGuildId(EntityPlayer p) 
    {
        int i = getDataBank().getTag(p, "gilde");
        if(i == 0)
        {
            i = -getDataBank().getIdByUUID(p.getUniqueID().toString());
        }
        return i;
    }
}
