package me.km.scoreboard;

import me.km.KajetansMod;
import me.km.dimensions.WorldPreferences;
import me.km.environment.EnvironmentAPI;
import net.minecraft.util.math.BlockPos;

public class ScoreboardRefresher implements Runnable
{
    private final ScoreboardAPI scoreboard;
    
    public ScoreboardRefresher(ScoreboardAPI scoreboard)
    {
        this.scoreboard = scoreboard;
    }
    
    @Override
    public void run() 
    {
        KajetansMod.server.getPlayerList().getPlayers().stream().forEach(p -> 
        {
            PlayerScoreboard data = scoreboard.getScoreboard(p);
            BlockPos l =  p.getPosition();
            data.addText(99, "§7LO §r" + l.getX() + "§7:§r" + l.getY() + "§7:§r" + l.getZ());
            data.addText(98, "§7HP §r" + (p.getHealth() * 100 / p.getMaxHealth()) + "§7%");
            WorldPreferences pref = KajetansMod.worldManager.getWorldPreferences(p.world);
            if(pref.statusEffects)
            {
                data.addText(78, new StringBuilder("§7EN §6||||||||||||||||||||").insert(EnvironmentAPI.getEnergy(p) / 500 + 7, "§c").toString());
                data.addText(77, new StringBuilder("§7TH §9||||||||||||||||||||").insert(EnvironmentAPI.getThirst(p) / 500 + 7, "§7").toString());
                data.addText(76, new StringBuilder("§7CO §3||||||||||||||||||||").insert(EnvironmentAPI.getCold(p) / 5 + 7, "§7").toString());
            }
            else
            {                  
                data.removeText(78);  
                data.removeText(77);  
                data.removeText(76);
            }
            if(pref.manabar)
            {
                data.addText(75, new StringBuilder("§7MP §9||||||||||||||||||||").insert(EnvironmentAPI.getMana(p) / 5 + 7, "§7").toString());
            }
            else
            {              
                data.removeText(75);
            }
            data.update();
        });
    }
}
