package me.km.skills;

import me.km.permissions.Permissions;
import me.km.api.GlobalText;
import me.km.api.Module;
import me.km.api.ModuleCommand;
import me.km.api.Utils;
import me.km.exception.PlayerNotFoundException;
import net.minecraft.command.ICommandSender;
import net.minecraft.entity.player.EntityPlayerMP;

public class CommandSkills extends ModuleCommand
{
    public CommandSkills(Module m) 
    {
        super("skills", m);
        super.setDescription("Zeigt die Skills eines Spielers");
        super.setUsage("/skills [player]");
        super.setPermission(Permissions.SKILLS);
    }

    @Override
    public boolean execute(ICommandSender cs, String[] arg) 
    {
        if(!(cs instanceof EntityPlayerMP))
        {
            this.getModule().send(cs, GlobalText.onlyPlayer());
            return true;
        }
        EntityPlayerMP p = (EntityPlayerMP) cs;
        
        EntityPlayerMP affectedPlayer;
        try
        {
            affectedPlayer = Utils.getPlayerByName(arg[0]);    
        }
        catch(PlayerNotFoundException ex)
        {
            this.getModule().send(cs, GlobalText.cantFindPlayer(arg[0]));
            return true;
        }
        catch(IndexOutOfBoundsException ex)
        {
            if(!(cs instanceof EntityPlayerMP))
            {
                this.getModule().send(cs, GlobalText.missingParameter());
                return true;
            }     
            affectedPlayer = (EntityPlayerMP) cs;
        }
        SkillMenuUtilities.openSkills(affectedPlayer, p);
        return true;
    } 
}
