package me.km.skills;

import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import me.km.KajetansMod;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraft.item.ItemStack;

public class SkillMenuUtilities 
{
    public static void openActiveSkills(EntityPlayerMP p)
    {
        List<Map.Entry<Skill, Byte>> list = KajetansMod.jobs.getSkillMap(p).entrySet().stream().filter(e -> e.getKey().isActive()).collect(Collectors.toList());
        List<ItemStack> stacks = list.stream().map(e -> e.getKey().getItemStack(e.getValue())).collect(Collectors.toList());
        ActiveSkillContainer active = new ActiveSkillContainer("Aktive Skills", p, stacks, list);
        active.openForPlayer(p);
    }
    
    public static void openSkills(EntityPlayerMP p, EntityPlayerMP show)
    {
        List<ItemStack> stacks = KajetansMod.jobs.getSkillMap(p).entrySet().stream().map(e -> e.getKey().getItemStack(e.getValue())).collect(Collectors.toList());
        SkillContainer skills = new SkillContainer("Skills", p, stacks, null);
        skills.openForPlayer(show);
    }
    
    public static void openRecipes(EntityPlayerMP p, EntityPlayerMP show)
    {
        List<ItemStack> stacks = KajetansMod.jobs.getRecipes(p).stream().map(m -> new ItemStack(m)).collect(Collectors.toList());
        SkillContainer skills = new SkillContainer("Crafting-Rezepte", p, stacks, null);
        skills.openForPlayer(show);
    }
}
