package me.km.snuviscript;

import me.km.KajetansMod;
import me.km.api.GlobalText;
import me.km.api.Module;
import me.km.api.ModuleCommand;
import me.km.api.Utils;
import me.km.chatmanager.ChatManager;
import java.util.Collection;
import java.util.List;
import java.util.Map;
import me.km.permissions.Permissions;
import net.minecraft.command.ICommandSender;
import net.minecraft.util.text.TextComponentString;

public class CommandScript extends ModuleCommand
{
    public CommandScript(Module m) 
    {
        super("script", m);
        super.setDescription("Zeigt alles über Scripts");
        super.setUsage("/script für die Hilfe");
        super.setPermission(Permissions.SCRIPT);
        super.addAlias("s");
    }

    @SuppressWarnings("unchecked")
    @Override
    public boolean execute(ICommandSender cs, String[] arg) 
    {
        Module m = this.getModule();
        if(arg.length >= 1)
        {
            switch(arg[0].toLowerCase())
            {
                case "s":
                case "start":
                {
                    if(arg.length >= 2)
                    {
                        KajetansMod.scripts.startScript(cs, arg[1]);
                        return true;
                    }
                    break;
                }
                case "v":
                case "variable":    
                {
                    if(arg.length >= 3)
                    {
                        try
                        {
                            Script qd = KajetansMod.scripts.getScript(Integer.parseInt(arg[1]));
                            if(qd == null)
                            {
                                throw new NumberFormatException();
                            }
                            m.send(cs, arg[2] + " = " + qd.getVar(arg[2]), 1);
                        }
                        catch(NumberFormatException ex)
                        {
                            m.send(cs, "'" + arg[1] + "' ist keine gültige ID.", 1);
                        }
                        return true;
                    }
                    break;
                }
                case "n":
                case "next":
                {
                    if(arg.length >= 2)
                    {
                        try
                        {
                            Script qd = KajetansMod.scripts.getScript(Integer.parseInt(arg[1]));
                            if(qd == null)
                            {
                                throw new NumberFormatException();
                            }
                            qd.setIsWaiting(false);
                            qd.runCode();
                        }
                        catch(NumberFormatException ex)
                        {
                            m.send(cs, "'" + arg[1] + "' ist keine gültige ID.", 1);
                        } 
                        return true;
                    }
                    break;
                }
                case "c":
                case "code":
                {
                    if(arg.length >= 3)
                    {
                        try
                        {
                            Script qd = KajetansMod.scripts.getScript(Integer.parseInt(arg[1]));
                            if(qd == null)
                            {
                                throw new NumberFormatException();
                            }
                            qd.runCodeLine(ChatManager.colorMessage(Utils.connectSpaces(arg, 2), cs), cs);
                        }
                        catch(NumberFormatException ex)
                        {
                            m.send(cs, "'" + arg[1] + "' ist keine gültige ID.", 1);
                        } 
                        return true;
                    }
                    break;
                }
                case "p":
                case "printvars":
                {
                    if(arg.length >= 2)
                    {
                        try
                        {
                            Script qd = KajetansMod.scripts.getScript(Integer.parseInt(arg[1]));
                            if(qd == null)
                            {
                                throw new NumberFormatException();
                            }
                            cs.sendMessage(new TextComponentString(GlobalText.Spacer()));
                            qd.getVars().entrySet().stream().filter(e -> arg.length < 3 || 
                                (e.getKey().startsWith(arg[2]))).forEach(e -> 
                            {
                                m.send(cs, e.getKey() + " = " + e.getValue(), 1);
                            }); 
                        }
                        catch(NumberFormatException ex)
                        {
                            m.send(cs, "'" + arg[1] + "' ist keine gültige ID.", 1);
                        } 
                        return true;
                    }
                    break;
                }
                case "pl":
                case "printlists":
                {
                    if(arg.length >= 2)
                    {
                        try
                        {
                            Script qd = KajetansMod.scripts.getScript(Integer.parseInt(arg[1]));
                            if(qd == null)
                            {
                                throw new NumberFormatException();
                            }
                            cs.sendMessage(new TextComponentString(GlobalText.Spacer()));
                            qd.getVars().entrySet().stream()
                                    .filter(e -> e.getValue() instanceof List)
                                    .filter(e -> arg.length < 3 || (e.getKey().startsWith(arg[2]))).forEach(e -> 
                            {
                                m.send(cs, e.getKey());
                                ((List<Object>) e.getValue()).forEach(l -> m.sendListElement(cs, l.toString()));
                            });   
                        }
                        catch(NumberFormatException ex)
                        {
                            m.send(cs, "'" + arg[1] + "' ist keine gültige ID.", 1);
                        }
                        return true;
                    }
                    break;
                }
                case "pm":
                case "printmaps":
                {
                    if(arg.length >= 2)
                    {
                        try
                        {
                            Script qd = KajetansMod.scripts.getScript(Integer.parseInt(arg[1]));
                            if(qd == null)
                            {
                                throw new NumberFormatException();
                            }
                            cs.sendMessage(new TextComponentString(GlobalText.Spacer()));
                            qd.getVars().entrySet().stream()
                                    .filter(e -> e.getValue() instanceof Map)
                                    .filter(e -> arg.length < 3 || (e.getKey().startsWith(arg[2]))).forEach(e -> 
                            {
                                m.send(cs, e.getKey());
                                ((Map) e.getValue()).forEach((k, v) -> m.sendListElement(cs, k + " | " + v));
                            });                   
                        }
                        catch(NumberFormatException ex)
                        {
                            m.send(cs, "'" + arg[1] + "' ist keine gültige ID.", 1);
                        }
                        return true;
                    }
                    break;
                }
                case "see":
                {
                    Collection<Script> scripts = KajetansMod.scripts.getScripts();
                    if(scripts.isEmpty())
                    {
                        m.send(cs, "Momentan sind keine Scripts aktiv.", 1);
                        return true;
                    }
                    m.send(cs, "Folgende Scripts sind aktiv:", 1);
                    scripts.forEach(data ->
                    {
                        m.sendHelpListElement(cs, data.getName(), "(" + data.getId() + ")", 1);
                    });
                    return true;
                }
                case "term":
                {
                    if(arg.length >= 2)
                    {
                        try
                        {
                            if(arg[1].equals("all"))
                            {
                                KajetansMod.scripts.removeScripts();
                                m.send(cs, "Alle aktiven Scripts wurden beendet.", 1);
                                return true;
                            }
                            Script qd = KajetansMod.scripts.getScript(Integer.parseInt(arg[1]));
                            if(!KajetansMod.scripts.term(qd))
                            {
                                throw new NumberFormatException();
                            }
                            m.send(cs, "Das Script '" + qd.getName() + "' wurde beendet.", 1);
                        }
                        catch(NumberFormatException ex)
                        {
                            m.send(cs, "'" + arg[1] + "' ist keine gültige ID.", 1);
                        } 
                        return true;
                    }
                    break;
                }
            }
        }
        
        m.send(cs, "/script ...", 1);
        m.sendHelpListElement(cs, "start <script>", "Startet ein Script", 1);
        m.sendHelpListElement(cs, "variable <id> <name>", "Zeigt den Wert einer Variable", 1);       
        m.sendHelpListElement(cs, "printvars <id> [starts]", "Zeigt alle Variablen", 1);
        m.sendHelpListElement(cs, "printlists <id> [starts]", "Zeigt alle Listen");
        m.sendHelpListElement(cs, "printmaps <id> [starts]", "Zeigt alle Maps");
        m.sendHelpListElement(cs, "next <id>", "Springt in die nächste Codezeile", 1);
        m.sendHelpListElement(cs, "code <id> <code", "Führt den angegebenen Code aus", 1);
        m.sendHelpListElement(cs, "see", "Gibt alle aktiven Scripts aus", 1);
        m.sendHelpListElement(cs, "term <id/all>", "Entfernt Scripts aus dem RAM", 1);
        return true;
    }
}

